#pragma once

#include <Datei.h>
#include <Vec2.h>
#include "Team.h"
#include "SpielKlasse.h"

class Spiel;
class Aktion;

struct SpielerTeamStruktur
{
    int spielerAnzahl;
    int teamAnzahl;
    Array< int > spielerFarbe;
    Array< int > teamFarbe;
    RCArray< Text > teamName;
    Array< int > teamSize;
};

class MapReader
{
private:
    SSDatenbankV *db;
    Text *pfad;
    int karteId;
    int ref;

    Aktion *readAktion( Datei &dat );

public:
    // Konstruktor
    MapReader( int karteId, SSDatenbankV *db, char *tmpPfad );
    // Destruktor
    ~MapReader();
    // nicht constant
    void ladeKarte( Spiel *zSpiel );
    // Reference Counting
    MapReader *getThis();
    MapReader *release();
};