#pragma once

#include "StatistikKlasse.h"
#include "SSDatenbankV.h"
#include "Spieler.h"
#include "Team.h"

class Statistik : public StatistikV
{
private:
    int spielId;
    int karteId;
    SSDatenbankV *db;
    RCArray< Spieler > *spieler;
    RCArray< Team > *teams;
    bool erstellt;
    Array< bool > *sOnline;
    Array< bool > *sBereit;
    int gewinnerTeam;
    int ref;

    void sendeStatistik( int index );

public:
    // Konstruktor
    Statistik();
    // Destruktor
    ~Statistik();
    // nicht constant
    void setSpielId( int id );
    void setKarteId( int id );
    void setPSQLDB( SSDatenbankV *db );
    void spielEnde( int team );
    void setTeams( RCArray< Team > *zTeams );
    void setSpieler( RCArray< Spieler > *zSpieler );
    virtual void klientOffline( int accountId );
    virtual void statistikAnfrage( int accountId, short len, char *bytes );
    virtual void run();
    // Reference Counting
    virtual StatistikV *getThis();
    virtual StatistikV *release();
};