#include "Tunnel.h"
#include "Spiel.h"


Tunnel::Tunnel( int id, int x, int y, int width, int height, int zielX, int zielY, bool aktiv )
    : GameObject( TUNNEL, x, y, width, height )
{
    this->id = id;
    this->aktiv = aktiv;
    benutzt = 0;
    this->zielX = zielX;
    this->zielY = zielY;
}

void Tunnel::setZielX( int x )
{
    zielX = x;
}

void Tunnel::setZielY( int y )
{
    zielY = y;
}

void Tunnel::addBenutzung( Spiel *zSpiel )
{
    zSpiel->setTunnelZuletztBenutzt( (Tunnel *)getThis() );
    benutzt++;
}

void Tunnel::setAktiv( bool aktiv )
{
    this->aktiv = aktiv;
}

int Tunnel::getZielX() const
{
    return zielX;
}

int Tunnel::getZielY() const
{
    return zielY;
}

bool Tunnel::istAktiv() const
{
    return aktiv;
}

int Tunnel::getBenutzungen() const
{
    return benutzt;
}

int Tunnel::getId() const
{
    return id;
}
